/*
 *  include/ub/ub_hash.h
 *
 *  Copyright (C) 2005  SWsoft
 *  All rights reserved.
 *  
 *  Licensing governed by "linux/COPYING.SWsoft" file.
 *
 */

#ifndef _LINUX_UBHASH_H
#define _LINUX_UBHASH_H

#ifdef __KERNEL__

#define UB_HASH_SIZE 256

struct ub_hash_slot {
	struct user_beancounter *ubh_beans;
};

extern struct ub_hash_slot ub_hash[];
extern spinlock_t ub_hash_lock;
extern struct list_head ub_list_head;

#ifdef CONFIG_USER_RESOURCE

/*
 * Iterate over beancounters
 * @__ubp - beancounter ptr
 * Can use break :)
 */
#define for_each_beancounter(__ubp)				\
	list_for_each_entry_rcu(__ubp, &ub_list_head, ub_list)	\

#endif /* CONFIG_USER_RESOURCE */
#endif /* __KERNEL__ */
#endif /* _LINUX_UBHASH_H */
